#! /bin/bash -f
AGGPATH=$PWD
XMLPATH=$PWD
JUNITPATH=$PWD
TESTPATH=$PWD
CLASS1TESTPATH=tests/graphs/Class1
AGGFILE=agg_V206_classes.jar
JGLFILE=jgl3.1.0.jar
COLIMFILE=colim.jar
JUNITFILE=junit.jar
TESTSCRIPT=run_tests
JAVA="java junit.swingui.TestRunner"

echo
echo "Which is your test root directory? [$TESTPATH]:"
read
if [ ${REPLY} ]; then
    TESTPATH=$REPLY
fi
echo
echo "Which is your AGG class package, if any? [$AGGFILE]:"
read
if [ ${REPLY} ]; then
    AGGFILE=$REPLY
fi
echo
echo "Where can I find $AGGFILE or which is your AGG root directory? [$AGGPATH]:"
read
if [ ${REPLY} ]; then
    AGGPATH=$REPLY
fi

echo "Which is your JUnit class package?  [$JUNITFILE]:"
read
if [ ${REPLY} ]; then
	JUNIT=$REPLY
fi
echo
echo "Where can I find $JUNITFILE ? [$JUNITPATH]:"
read
if [ ${REPLY} ]; then
    JUNITPATH=$REPLY
fi

echo
echo "Which name do you want for your test start script? [$TESTSCRIPT]:"
read
if [ ${REPLY} ]; then
    TESTSCRIPT=$REPLY
fi
echo
echo "============================================================="
INSTALLDIR=$PWD


echo
echo "Creating start script $TESTSCRIPT with the following items:"
echo "export CLASSPATH=$AGGPATH:$AGGPATH/$AGGFILE:$TESTPATH/$CLASS1TESTPATH:$JUNITPATH/$JUNITFILE:$JUNITPATH"
echo
echo "ORIGINALPWD=\$PWD"
echo "cd $TESTPATH/tests"
echo "$JAVA"
echo "cd \$ORIGINALPWD"
echo
echo
echo "=========="
echo "If an entry is wrong please restart the installation script."
echo 
echo "To start the testscript just type ./$TESTSCRIPT and <RETURN>"
echo


echo "#! /usr/bin/bash -f" > $TESTSCRIPT
echo "export CLASSPATH=$TESTPATH/tests:$AGGPATH:$AGGPATH/$AGGFILE:$TESTPATH/$CLASS1TESTPATH:$JUNITPATH/$JUNITFILE:$JUNITPATH" >> $TESTSCRIPT
echo >> $TESTSCRIPT
echo "ORIGINALPWD=\$PWD" >> $TESTSCRIPT
echo "cd $TESTPATH/tests" >> $TESTSCRIPT
echo "$JAVA" >> $TESTSCRIPT
echo "cd \$ORIGINALPWD" >> $TESTSCRIPT
chmod 755 $TESTSCRIPT
