import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class CPCons1Test extends TestCase {
	private boolean compResult;
	private CompCritical myTest;

	//adjust these values to the new test case
	private String path = new String("criticals/Cons1/");
	private int criticalpairs = 0;
	
	public CPCons1Test(String name) {
    	super(name);
	}

	/** import grammar and perform critical pair analysis
	  */
	protected void setUp() {
		myTest = new CompCritical();
		myTest.importGrammar(path + "grammar.ggx");
        myTest.createCriticals();
	}
 
	/** test whether the number of created critical pairs correspond with the expected number
	  */
	public void testCorrectNumber(){
		Assert.assertTrue( myTest.numberOfCriticals(criticalpairs) );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(CPCons1Test.class);
    }
}
