import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class CPNac6Test extends TestCase {
	private boolean compResult;
	private CompCritical myTest;

	//adjust these values to the new test case
	private String path = new String("criticals/Nac6/");
	private int criticalpairs = 2;
	
	public CPNac6Test(String name) {
    	super(name);
	}

	/** import grammar and perform critical pair analysis
	  */
	protected void setUp() {
		myTest = new CompCritical();
		myTest.importGrammar(path + "grammar.ggx");
        myTest.createCriticals();
	}
 
	/** compare the generated critical pairs to the expected results
	  */
	public void testCriticalPairs() {
		String filename;
		File f;
		int i;
		//each grammar always contains the first critical pair
		Assert.assertTrue( myTest.compareCritical() );

		// check for additional critical pairs if there are any
		i = 2;
		filename = new String(path + "pair" + i + ".ggx");
		f = new File(filename);
		while (f.exists()){
			Assert.assertTrue( myTest.compareCritical(filename) );
			++i;
			filename = new String(path + "pair" + i + ".ggx");
			f = new File(filename);
		}
	}

	/** test whether the number of created critical pairs correspond with the expected number
	  */
	public void testCorrectNumber(){
		Assert.assertTrue( myTest.numberOfCriticals(criticalpairs) );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(CPNac6Test.class);
    }
}
