import java.util.*;
import java.io.*;

//import com.objectspace.jgl.Pair;

import agg.xt_basis.*;
import agg.*;
import agg.parser.*;
import agg.util.*;

public class CompCritical {
	private static GraGra gragra;
	private static Vector CriticalPairs;

	/** loads an AGG grammar from the given file
	  *
	/*public static GraGra load(String fileName) {
		if (fileName.endsWith(".ggx")) {
			XMLHelper h = null;
			h = new XMLHelper();
			h.read_from_xml(fileName);
			GraGra gra = (GraGra) h.getTopObject(BaseFactory.theFactory().createGraGra());
			return gra;
		}
		else 
			return null;
	}
	*/

	/** import an AGG grammar
	  */
	public static void importGrammar(String filename) {
		gragra = BaseFactory.theFactory().createGraGra();
		try {
			gragra.load(filename);
		} catch (Exception ex) {}
	}

	/** use the current set of rules to create the critical pairs
	  * ATTENTION: Only critical pairs between the rule named "Rule1" and the rule named "Rule2" will be created
	  */
	public static void createCriticals() {
		// prepare
		CriticalPairOption cpOption = new CriticalPairOption();
		cpOption.enableConsistent(true);
		cpOption.enableStrongAttrCheck(false);
		ExcludePairContainer myContainer = (ExcludePairContainer) ParserFactory.createEmptyCriticalPairs(gragra, null, cpOption);
		if (gragra == null) {
			System.out.println("no gragra found");
			return;
		}
System.out.println();
System.out.println("Test Filename: "+gragra.getDirName()+gragra.getFileName());		
		if (gragra.getRule("Rule1") != null && gragra.getRule("Rule2") != null)
			try {
				//System.out.println("Generating critical pairs");
				//gragra.setGraTraOptions(new Completion_InjCSP());
				gragra.setGraTraOptions(new Completion_NAC(new Completion_InjCSP()));
				Vector temp = (Vector) myContainer.getCritical(gragra.getRule("Rule1"), gragra.getRule("Rule2"), CriticalPair.EXCLUDE, true);
//System.out.println(temp);
				CriticalPairs = (Vector) myContainer.getLHSoverlappings(gragra.getRule("Rule1"), gragra.getRule("Rule2"), temp);
//System.out.println(CriticalPairs);
			}
			catch(Exception e) {
				//System.out.println(e);
				e.printStackTrace();
			}
	}

	/** compares the number of created critical pairs with the given number
	  */
	public static boolean numberOfCriticals(int value) {
		if (CriticalPairs == null && value == 0)
			return true;
		if (CriticalPairs != null && value == CriticalPairs.size())
			return true;
		return false;
	}

	/** compare the generated critical pairs with those contained in the current grammar
	  */
	public static boolean compareCritical() {
		int j, k;
		boolean result;
		Graph working = gragra.getGraph(); // the working graph of the grammar (should be isomorph to an overlapping graph of a critical pair)
		Graph overlap; // our current overlap taken from a critical pair
		OrdinaryMorphism f; // an injective Morphism from the grammars working graph to the critical pair overlapping graph
		OrdinaryMorphism m1; // match from the LHS of the rule named "Rule1" into the working graph
		OrdinaryMorphism m2; // match from the LHS of the rule named "Rule2" into the working graph
		OrdinaryMorphism om1; // match from the LHS of the rule named"Rule1" into the overlap graph of a critical pair
		OrdinaryMorphism om2; // match from the LHS of the rule named"Rule2" into the overlap graph of a critical pair
		OrdinaryMorphism f_m1; // composition of the original match for rule1 into the working graph and the newly found morphism f
		OrdinaryMorphism f_m2; // composition of the original match for rule2 into the working graph and the newly found morphism f
		Rule r1 = gragra.getRule("Rule1");
		Rule r2 = gragra.getRule("Rule2");
		Pair currentCritical; // our current critical pair
		GraphObject currentObject; // used to fill the morphismn between working and overlap graph with the match induced pairs
		Enumeration LHSObjects; // those objects contained in the LHS of both rules
		
		//if there are no critical pairs dont bother testing
		if (CriticalPairs == null)
			return false;
		
		//get the matches from both rules into the working graph from the loaded grammar
		if (r1 != null)
			m1 = r1.getMatch();
		else
			m1 = null;
		
		if (r2 != null)
			m2 = r2.getMatch();
		else
			m2 = null;

		// There was a problem getting proper matches out of the grammar. Have you set all matches?
		if (m1 == null || m2 == null)
			return false;

		/*
		if (CriticalPairs != null)
			System.out.println("There are " + CriticalPairs.size() + " critical pairs");
		else
			System.out.println("Critical pair finding failed");
		*/
			
		// find a morphism from the working graph into the overlap graph from a critical pair
		for (j = 0; j < CriticalPairs.size(); j++) {
			result = true;
			currentCritical = (Pair) CriticalPairs.elementAt(j);
			
			om1 = (OrdinaryMorphism) currentCritical.first;
			om2 = (OrdinaryMorphism) currentCritical.second;


			//Pair temp1 = (Pair) currentCritical.first;
			//Pair temp2 = (Pair) currentCritical.second;

			/*
			if (temp2 == null) {
				om1 = (OrdinaryMorphism) temp1.first;
				om2 = (OrdinaryMorphism) temp1.second;
			}
			else {
				if (((OrdinaryMorphism) temp1.first).getSource() == r1.getRight())
					om1 = r1.compose((OrdinaryMorphism) temp2.first);
				else
					om1 = (OrdinaryMorphism) temp1.first;
				om2 = ((OrdinaryMorphism) temp2.first).compose((OrdinaryMorphism) temp1.second);
				//produce-forbid-conflict
				if (r2.getTarget() == ((OrdinaryMorphism) temp1.first).getSource()) {
					om1 = r1.compose((OrdinaryMorphism) temp2.first);
					overlap = (Graph) om1.getImage();
					String nac = overlap.info; // NAC name
					OrdinaryMorphism nac2 = r2.getNAC(nac);
					OrdinaryMorphism n2 = nac2.compose((OrdinaryMorphism) temp2.second);
					om2 = n2.compose((OrdinaryMorphism) temp1.second);
				}
				else {
						
				}
			}*/
			
			
			overlap = (Graph) om1.getImage();

			System.out.println("Status: " + (overlap.getSize() == working.getSize()));
//System.out.println(overlap.getSize()+" ?= "+working.getSize());
//System.out.println(overlap.hashCode()+"   "+overlap);
			// prepare the morphism between the working and overlap graph
			f = (BaseFactory.theFactory()).createMorphism(working, overlap);
			f.setCompletionStrategy(new Completion_InjCSP());

			// create mappings for objects from first rule
			LHSObjects = m1.getOriginal().getElements();
			while (LHSObjects.hasMoreElements()){
				currentObject = (GraphObject) LHSObjects.nextElement();
				f.addMapping (m1.getImage (currentObject), om1.getImage (currentObject));
				
				/*
				System.out.println("m1 Image: " + m1.getImage (currentObject));
				System.out.println("om1 Image: " + om1.getImage (currentObject));
				if (f.getImage(m1.getImage (currentObject)) == null)
					System.out.println("Warning: Mapping failed");
				*/
				
			}
			
			// create mappings for objects from second rule
			LHSObjects = m2.getOriginal().getElements();
			while (LHSObjects.hasMoreElements()){
				currentObject = (GraphObject) LHSObjects.nextElement();
				if (f.getImage(m2.getImage(currentObject)) == null || f.getImage(m2.getImage(currentObject)) == om2.getImage(currentObject))
					f.addMapping (m2.getImage (currentObject), om2.getImage (currentObject));
				else
					result = false;
			
				/*
				System.out.println("m2 Image: " + m2.getImage (currentObject));
				System.out.println("om2 Image: " + om2.getImage (currentObject));
				if (f.getImage(m2.getImage (currentObject)) == null)
					System.out.println("Warning: Mapping failed");
				*/
				
			}
			
			// find a match for the remaining objects
			if(f.nextCompletionWithConstantsChecking()) {
				Enumeration e = overlap.getElements();
				while(result && e.hasMoreElements()) {
					GraphObject o = (GraphObject) e.nextElement();
					if(!f.getInverseImage(o).hasMoreElements())
						result = false;
				}
				e = working.getElements();
				while(result && e.hasMoreElements()) {
					GraphObject o = (GraphObject) e.nextElement();
					GraphObject i = (GraphObject) f.getImage(o);
					if(!o.compareTo(i))
						result = false;
				}

				// there is no isomorphism between the working graph and this overlap, try next one
				if (result == false)
					continue;
			}
			
			/*
			System.out.println("Total: " + f.isTotal());
			System.out.println("Injective: " + f.isInjective());
			LHSObjects = f.getOriginal().getElements();
			while (LHSObjects.hasMoreElements()) {
				tempObj =  (GraphObject) currentObject.nextElement();
				System.out.println (currentObject + " is mapped to " + f.getImage (tempObj));
			}
			*/
		
			/*
			LHSObjects = f.getOriginal().getElements();
			while (LHSObjects.hasMoreElements()){
				currentObject = (GraphObject) LHSObjects.nextElement();
				System.out.println(currentObject + " -> " + f.getImage(currentObject));
			}
			*/

			f_m1 = m1.compose(f);
			f_m2 = m2.compose(f);
			
			if (f_m1.compareTo(om1) && f_m2.compareTo(om2))
				return true;
		}
		return false;
	}

	/** can be used to compare additional critical pairs against the same grammar without recreating all critical pairs
	  */
	public static boolean compareCritical(String filename) {
		importGrammar(filename);
		createCriticals();
		return compareCritical();
	}
	
	public static void main(String[] args) {
		boolean result;
			
		importGrammar("/home/tfs/enrico/testsuite/tests/criticals/Nac3/pair2.ggx");
		createCriticals();
		result = compareCritical();
		System.out.println("Result: " + result);
	}
}

