import java.util.*;
import java.io.*;

import agg.xt_basis.*;
import agg.*;
import agg.util.*;

public class CompGrammar {
	private static GraGra gragra;
	private static GraGra testgra;
	private static GraTra gratra;

	public static GraGra load(String fileName) {
		if (fileName.endsWith(".ggx")) {
			XMLHelper h = null;
			h = new XMLHelper();
			h.read_from_xml(fileName);

			// create a gragra
			GraGra gra = (GraGra) h.getTopObject(BaseFactory.theFactory().createGraGra());
			return gra;
		}
		else return null;
	}

	public static void transform(GraGra gragra) {
		if (gragra == null) return;

		// create trafo
		//System.out.println(gragra.getGraTraOptions().toString());
		if (gragra.getGraTraOptions().contains("layered"))
			gratra = new LayeredGraTraImpl();
		else
			gratra = new DefaultGraTraImpl();

		gratra.setGraGra(gragra);
		gratra.setHostGraph(gragra.getGraph());

		int s = gragra.getGraTraOptions().size();
		MorphCompletionStrategy strategy = CompletionStrategySelector.getDefault();
		switch (s) {
			case 0:
				gratra.setCompletionStrategy(strategy);
				gragra.setGraTraOptions(strategy);       
				break;
			case 1:
				if (gragra.getGraTraOptions().elementAt(0).equals("layered")) {
					gratra.setCompletionStrategy(strategy);
					gragra.setGraTraOptions(strategy); 
					gragra.getGraTraOptions().add("layered");
					gratra.getGraTraOptions().addOption("layered");
				}
				else
					gratra.setGraTraOptions(gragra.getGraTraOptions());
				break;
			default:
				gratra.setGraTraOptions(gragra.getGraTraOptions());
		}
		//System.out.println(gragra.getMorphismCompletionStrategy());
		//System.out.println(gratra.getCompletionStrategy());
		//gragra.putMorphismCompletionStrategyToGraphConstraints();
		gragra.setGraTraOptions(strategy);       
		gratra.transform();
	}

	public void importGrammar(String filename) {
		gragra = BaseFactory.theFactory().createGraGra();
		try {
			gragra.load(filename);
		} catch (Exception ex) {}
	}

	public void importCompareGraph(String filename) {
		testgra = BaseFactory.theFactory().createGraGra();
		try {
			testgra.load(filename);
		} catch (Exception ex) {}
	}
		
	public void outputDebugGraph(String filename) {
		gragra.save(filename);
	}
	
	public void performTransformation() {
		transform(gragra);
	}

	public boolean compareResult() {
		//MorphCompletionStrategy myMorph = CompletionStrategySelector.getDefault();
		//myMorph.showProperties();
		return (gragra.getGraph().compareTo(testgra.getGraph()) && testgra.getGraph().compareTo(gragra.getGraph()));
	}
}

