import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class CompareTest extends TestCase {
	private boolean compResult;
	private CompGrammar myTest;
	
	public CompareTest( String name ) {
    	super(name);  
	}

	/** import and transform the grammar
	  */
	protected void setUp() {
		myTest = new CompGrammar();
		myTest.importGrammar("graphs/Compare/compare1.ggx");
        myTest.performTransformation();
		myTest.importCompareGraph("graphs/Compare/compare2.ggx");
	}
 
	/** compare the grammar to the expected results
	  */
	public void testGraphComparision() {
		compResult = myTest.compareResult();
		if( compResult )
			myTest.outputDebugGraph("debug/CompareDebug.ggx");
		Assert.assertTrue( !compResult );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(CompareTest.class);
    }
}
