import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class CondNac1Test extends TestCase {
	private boolean compResult;
	private CompGrammar myTest;
	
	public CondNac1Test( String name ) {
    	super(name);  
	}

	/** import and transform the grammar
	  */
	protected void setUp() {
		myTest = new CompGrammar();
		myTest.importGrammar("graphs/CondNac1/grammar.ggx");
        myTest.performTransformation();
	}
 
	/** compare the grammar to the expected results
	  */
	public void testNacCondition() {
		myTest.importCompareGraph("graphs/CondNac1/compare1.ggx");
		compResult = myTest.compareResult();
		myTest.importCompareGraph("graphs/CondNac1/compare2.ggx");
		compResult = compResult || myTest.compareResult();
		if( !compResult )
			myTest.outputDebugGraph("debug/CondNac1Debug.ggx");
		Assert.assertTrue( compResult );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(CondNac1Test.class);
    }
}
