import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class IHCond1Test extends TestCase {
	private boolean compResult;
	private CompGrammar myTest;
	
	public IHCond1Test( String name ) {
    	super(name);  
	}

	/** import and transform the grammar
	  */
	protected void setUp() {
		myTest = new CompGrammar();
		myTest.importGrammar("inheritance/Cond1/grammar.ggx");
        myTest.performTransformation();
	}
 
	/** compare the grammar to the expected results
	  */
	public void testConditionInheritance() {
		myTest.importCompareGraph("inheritance/Cond1/compare.ggx");
		compResult = myTest.compareResult();
		if( !compResult )
			myTest.outputDebugGraph("debug/IHCond1Debug.ggx");
		Assert.assertTrue( compResult );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(IHCond1Test.class);
    }
}
