import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class IHNac2Test extends TestCase {
	private boolean compResult;
	private CompGrammar myTest;
	
	public IHNac2Test( String name ) {
    	super(name);  
	}

	/** import and transform the grammar
	  */
	protected void setUp() {
		myTest = new CompGrammar();
		myTest.importGrammar("inheritance/Nac2/grammar.ggx");
        myTest.performTransformation();
	}
 
	/** compare the grammar to the expected results
	  */
	public void testNacInheritance() {
		myTest.importCompareGraph("inheritance/Nac2/compare.ggx");
		compResult = myTest.compareResult();
		if( !compResult )
			myTest.outputDebugGraph("debug/IHNac2Debug.ggx");
		Assert.assertTrue( compResult );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(IHNac2Test.class);
    }
}
