
import java.io.*;

public class List {

	private ListNode current;

	public List(){
		super();
		Initialize();
	}

	public List( int a ){
		super();
		Initialize();
	}

	private void Initialize(){
		current = new ListNode(new Integer(0));
	}
	
	public List createNode( Integer val ){
		current.next = new ListNode(new Integer(0));
		current.next.prev = current;
		current = current.next;	
		current.value = val;
		return this;
	}

	public int getFirst(){
		int val;
		if( current.prev != null )
			val = current.value.intValue();
		else
			val = 0;
		return val;
	}

	public int removeNode(){
		int val;
		if( current.prev != null ){
			val = current.value.intValue();
			current = current.prev;
			current.next = null;
			return val;
		}
		return 0;
	}

	public boolean isEmpty(){
		if( current.prev == null )
			return true;
		else
			return false;
	}


	public String toString() {
		ListNode n = current;
		String s = ""; 
		while (n.prev != null) {	
			s = String.valueOf(n.value.intValue()) +"," + s;
			n = n.prev;
		}
		if (s.length() > 0)
			s = s.substring(0, s.length()-1);
		s = "\"" + s + "\"";
		return s;
	}

	public static void main(String args[]){
		int a;
		List myList = new List(8);

		myList.Initialize();
		
		a = 47;
		myList.createNode(new Integer(a));
		a = 42;
		myList.createNode(new Integer(a));
		System.out.println(myList.toString());
		a = myList.removeNode();
		System.out.println(a);
		System.out.println(myList.toString());
		a = myList.removeNode();
		System.out.println(a);
		System.out.println(myList.toString());
	}
}
