import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class NoInj1Test extends TestCase {
	private boolean compResult;
	private CompGrammar myTest;
	
	public NoInj1Test( String name ) {
    	super(name);  
	}

	/** import and transform the grammar
	  */
	protected void setUp() {
		myTest = new CompGrammar();
		myTest.importGrammar("graphs/NoInj1/grammar.ggx");
        myTest.performTransformation();
	}
 
	/** compare the grammar to the expected results
	  */
	public void testNonInjectiveRule() {
		myTest.importCompareGraph("graphs/NoInj1/compare.ggx");
		compResult = myTest.compareResult();
		if( !compResult )
			myTest.outputDebugGraph("debug/NoInj1Debug.ggx");
		Assert.assertTrue( compResult );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(NoInj1Test.class);
    }
}
