import java.io.File;

import junit.framework.TestCase;
import junit.framework.Assert;
import junit.framework.TestSuite;
import junit.framework.Test;

public class NoInjNac2Test extends TestCase {
	private boolean compResult;
	private CompGrammar myTest;
	
	public NoInjNac2Test( String name ) {
    	super(name);  
	}

	/** import and transform the grammar
	  */
	protected void setUp() {
		myTest = new CompGrammar();
		myTest.importGrammar("graphs/NoInjNac2/grammar.ggx");
        myTest.performTransformation();
	}
 
	/** compare the grammar to the expected results
	  */
	public void testNonInjectiveNAC() {
		myTest.importCompareGraph("graphs/NoInjNac2/compare.ggx");
		compResult = myTest.compareResult();
		if( !compResult )
			myTest.outputDebugGraph("debug/NoInjNac2Debug.ggx");
		Assert.assertTrue( compResult );
	}

	/** run all tests declared in this class
	  */
	public static Test suite() {
        return new TestSuite(NoInjNac2Test.class);
    }
}
